<%@ Page Language="VB" debug="true" explicit="true" strict="true"%>
<script language="vb" runat="server">
Sub Copy_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
	'convert our source path into a physical path
	Dim sourcePath As String = Server.MapPath(tbxSourceDir.Text)
	'get the folder we want to copy from
	Dim arrSourcePath() As String = RegEx.Split(tbxSourceDir.Text, "/")
	Dim lastFolder As String = arrSourcePath(UBound(arrSourcePath))
	'get our destination path as physical
	Dim destPath As String = Server.MapPath(tbxDestinationDir.Text + "/" + lastFolder) 
	Try
		CopyDirectory(sourcePath, destPath, True)
	Catch exc As System.Exception
		lblStatusMessage.Text = exc.Message
		lblStatusMessage.Visible = True
	End Try
End Sub

Private Sub CopyDirectory(sourcePath As String, destPath As String, overwrite As Boolean)
    Dim sourceDir As System.IO.DirectoryInfo = New System.IO.DirectoryInfo(sourcePath)
    Dim destDir As System.IO.DirectoryInfo = New System.IO.DirectoryInfo(destPath)
    'The source directory must exist for our code to run
    If (sourceDir.Exists) Then
		'if the destination folder does not exist, create it
        If Not (destDir.Exists) Then
            destDir.Create()
        End If
        'loop through all the files of the current directory
        'and copy them if overwrite=true or they do not exist
        Dim file As System.IO.FileInfo
        For Each file In sourceDir.GetFiles()
            If (overwrite) Then
                file.CopyTo(System.IO.Path.Combine(destDir.FullName, file.Name), True)
            Else
                If ((System.IO.File.Exists(System.IO.Path.Combine(destDir.FullName, file.Name))) = False) Then
                    file.CopyTo(System.IO.Path.Combine(destDir.FullName, file.Name), False)
                End If
            End If
        Next
        'loop through all the subfolders and call this method recursively
        Dim dir As System.IO.DirectoryInfo
        For Each dir In sourceDir.GetDirectories()
			If (dir.FullName <> Server.MapPath(tbxDestinationDir.Text)) Then
				CopyDirectory(dir.FullName, System.IO.Path.Combine(destDir.FullName, dir.Name), overwrite)
			End If
        Next
        lblStatusMessage.Text = "Folder copied successfully"
		lblStatusMessage.Visible = True
	'if source directory does not exist
	Else
		lblStatusMessage.Text = "Error: source folder does not exist!"
		lblStatusMessage.Visible = True
    End If
End Sub
</script>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<style TYPE="text/css">
body {
	font-family: Verdana;
	font-size: 70%;
}
table tr td {
	font-family: Verdana;
	font-size: 70%;
}
</style>
</head>
<body>
<h4>Copying a Directory with ASP.NET</h4>
<form runat="server">
<table border="0" cellpadding="3" cellspacing="2" bgcolor="#cccccc">
<tr>
	<td>Type the source directory:</td>
	<td><asp:TextBox Runat="server" ID="tbxSourceDir"></asp:TextBox></td>
</tr>
<tr>
	<td>Type the destination directory:</td>
	<td><asp:TextBox Runat="server" ID="tbxDestinationDir"></asp:TextBox></td>
</tr>
<tr>
	<td colspan="2"><asp:Button Runat="server" ID="btnCopy" OnClick="Copy_Click" Text="Click to Copy"></asp:Button></td>
</tr>
</table>
<br>
<asp:Label Runat="server" ID="lblStatusMessage" Visible="False" ForeColor="#ff0000"></asp:Label>
</form>
</body>
</html>